package cn.ibizlab.humanresource.core.humanresource.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.humanresource.core.humanresource.domain.HRContract;
import cn.ibizlab.humanresource.core.humanresource.filter.HRContractSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[HRContract] 服务对象接口
 */
public interface IHRContractService extends IService<HRContract>{

    boolean create(HRContract et) ;
    void createBatch(List<HRContract> list) ;
    boolean update(HRContract et) ;
    void updateBatch(List<HRContract> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    HRContract get(String key) ;
    HRContract getDraft(HRContract et) ;
    boolean checkKey(HRContract et) ;
    boolean save(HRContract et) ;
    void saveBatch(List<HRContract> list) ;
    Page<HRContract> searchActive(HRContractSearchContext context) ;
    Page<HRContract> searchDefault(HRContractSearchContext context) ;
    Page<HRContract> searchWaitSign(HRContractSearchContext context) ;
    Page<HRContract> searchWaitStop(HRContractSearchContext context) ;
    List<HRContract> selectByHremployeeid(String employeeid) ;
    void removeByHremployeeid(String employeeid) ;
    List<HRContract> selectByMgrorganizationid(String organizationid) ;
    void removeByMgrorganizationid(String organizationid) ;
    List<HRContract> selectBySignorganizationid(String organizationid) ;
    void removeBySignorganizationid(String organizationid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<HRContract> getHrcontractByIds(List<String> ids) ;
    List<HRContract> getHrcontractByEntities(List<HRContract> entities) ;
}


